package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: CreateKeyPage

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("CreateKeyPage")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class CreateKeyPage implements TransactionBody {
	public final TransactionType type = TransactionType.CREATE_KEY_PAGE;
	private KeySpecParams[] keys;

    //
	public KeySpecParams[] getKeys() {
	    return keys;
	}
	public void setKeys(final KeySpecParams[] value) {
	    this.keys = value;
	}

	public CreateKeyPage keys(final KeySpecParams[] value) {
	    setKeys(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.keys == null)) {
            marshaller.writeValue(2, keys);
        }
        return marshaller.array();
    }
}
